
#define NOCCARGC
#include stdio.h
#include clib.def
/*
** Open file indicated by fn.
** Entry: fn  = Null-terminated CP/M file name.
**              May be prefixed with letter of drive.
**        mode =  "a"   -append
**                "r"   -read
**                "w"   -write
**                "a+"  -append update
**                "r+"  -read update
**                "w+"  -write update
** Returns a file descriptor on success, else NULL.
*/
fopen(fn, mode) char *fn, *mode; {
  int fd;
  fd = 0; /*skip stdin (= error return) */
  while(++fd < MAXFILES) {
    if(_mode(fd) == NULL) {
      if(_open(fn, mode, fd)!=ERR) return (fd);
      break;
      }
    }
  return (NULL);
  }

